/*********************************************************************
	Rhapsody in C	: 8.2.1 
	Login		: LocalAdministrator
	Component	: Cortex_CMP 
	Configuration 	: Debug
	Model Element	: Rectangle
//!	Generated Date	: Sat, 19, Aug 2017  
	File Path	: Cortex_CMP\Debug\Rectangle.c
*********************************************************************/

/*## auto_generated */
#include "Rectangle.h"
/*## link itsGLCD */
#include "GLCD.h"
/*## package b_GraphicLibPkg */

/*## class Rectangle */

/*#[ ignore */

/* Beginning start section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_START_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_START_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending start section to allocate CODE and DATA into Memory Sections */


/*#]*/


/*## auto_generated */
static void cleanUpRelations(Rectangle* const me);

/*## operation Init(uint16_t,uint16_t,uint16_t,uint16_t,uint16_t) */
void Rectangle_Init(Rectangle* const me, const uint16_t aX, const uint16_t aY, const uint16_t aXS, const uint16_t aYS, const uint16_t aColor)
{
    me->itsGLCD = NULL;
    {
        /*#[ operation Init(uint16_t,uint16_t,uint16_t,uint16_t,uint16_t) */
        me->x  = aX;
        me->xs = aXS;
        me->y  = aY;
        me->ys = aYS;
        
        me->myColor = aColor;
    
        /*#]*/
    }
}

void Rectangle_Cleanup(Rectangle* const me)
{
    cleanUpRelations(me);
}

/*## operation draw() */
void Rectangle_draw(Rectangle* const me)
{
    /*#[ operation draw() */
    GLCD_SetWindow(me->itsGLCD, me->x, me->y, me->xs, me->ys); 
    GLCD_ClearColor(me->itsGLCD, me->myColor);
    
    /*#]*/
}

struct GLCD* Rectangle_getItsGLCD(const Rectangle* const me)
{
    return (struct GLCD*)me->itsGLCD;
}

void Rectangle_setItsGLCD(Rectangle* const me, struct GLCD* p_GLCD)
{
    me->itsGLCD = p_GLCD;
}

Rectangle * Rectangle_Create(const uint16_t aX, const uint16_t aY, const uint16_t aXS, const uint16_t aYS, const uint16_t aColor)
{
    Rectangle* me = (Rectangle *) malloc(sizeof(Rectangle));
    if(me!=NULL)
        {
            Rectangle_Init(me, aX, aY, aXS, aYS, aColor);
        }
    return me;
}

void Rectangle_Destroy(Rectangle* const me)
{
    if(me!=NULL)
        {
            Rectangle_Cleanup(me);
        }
    free(me);
}

static void cleanUpRelations(Rectangle* const me)
{
    if(me->itsGLCD != NULL)
        {
            me->itsGLCD = NULL;
        }
}


/*#[ ignore */

/* Beginning stop section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_STOP_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_STOP_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending stop section to allocate CODE and DATA into Memory Sections */


/*#]*/

/*********************************************************************
	File Path	: Cortex_CMP\Debug\Rectangle.c
*********************************************************************/
