/*********************************************************************
	Rhapsody in C	: 8.2.1 
	Login		: LocalAdministrator
	Component	: Cortex_CMP 
	Configuration 	: Debug
	Model Element	: Rectangle
//!	Generated Date	: Sat, 19, Aug 2017  
	File Path	: Cortex_CMP\Debug\Rectangle.h
*********************************************************************/

#ifndef Rectangle_H
#define Rectangle_H

/*## auto_generated */
#include "WST.h"
/*## auto_generated */
#include <stdint.h>
/*## auto_generated */
#include <stdbool.h>
/*## auto_generated */
#include "b_GraphicLibPkg.h"
/*## link itsGLCD */
struct GLCD;

/*## package b_GraphicLibPkg */

/*## class Rectangle */

/*#[ ignore */

/* Beginning start section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_START_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_START_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending start section to allocate CODE and DATA into Memory Sections */


/*#]*/


typedef struct Rectangle Rectangle;
struct Rectangle
{
    uint32_t myColor;		/*## attribute myColor */
    uint32_t x;		/*## attribute x */
    uint32_t xs;		/*## attribute xs */
    uint32_t y;		/*## attribute y */
    uint32_t ys;		/*## attribute ys */
    struct GLCD* itsGLCD;		/*## link itsGLCD */
};

/***    User implicit entries    ***/


/* Constructors and destructors:*/

/*## operation Init(uint16_t,uint16_t,uint16_t,uint16_t,uint16_t) */
void Rectangle_Init(Rectangle* const me, const uint16_t aX, const uint16_t aY, const uint16_t aXS, const uint16_t aYS, const uint16_t aColor);

/*## auto_generated */
void Rectangle_Cleanup(Rectangle* const me);

/***    User explicit entries    ***/


/* Operations */

/*## operation draw() */
void Rectangle_draw(Rectangle* const me);

/*## auto_generated */
struct GLCD* Rectangle_getItsGLCD(const Rectangle* const me);

/*## auto_generated */
void Rectangle_setItsGLCD(Rectangle* const me, struct GLCD* p_GLCD);

/*## auto_generated */
Rectangle * Rectangle_Create(const uint16_t aX, const uint16_t aY, const uint16_t aXS, const uint16_t aYS, const uint16_t aColor);

/*## auto_generated */
void Rectangle_Destroy(Rectangle* const me);


/*#[ ignore */

/* Beginning stop section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_STOP_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_STOP_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending stop section to allocate CODE and DATA into Memory Sections */


/*#]*/

#endif
/*********************************************************************
	File Path	: Cortex_CMP\Debug\Rectangle.h
*********************************************************************/
