/*********************************************************************
	Rhapsody in C	: 8.2.1 
	Login		: LocalAdministrator
	Component	: Cortex_CMP 
	Configuration 	: Debug
	Model Element	: SPI
//!	Generated Date	: Sat, 19, Aug 2017  
	File Path	: Cortex_CMP\Debug\SPI.h
*********************************************************************/

#ifndef SPI_H
#define SPI_H

/*## auto_generated */
#include "WST.h"
/*## auto_generated */
#include <stdint.h>
/*## auto_generated */
#include <stdbool.h>
/*## auto_generated */
#include "a_SPI_Lib.h"
/*## dependency lpc17xx */
#include <lpc17xx.h>
/*## operation spi_tran_man(uint8_t,datamode_t) */
#include "TypesPkg.h"
/*## package a_SPI_Lib */

/*## class TopLevel::SPI */

/*#[ ignore */

/* Beginning start section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_START_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_START_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending start section to allocate CODE and DATA into Memory Sections */


/*#]*/


struct SPI_t
{
    int16_t driverCode;		/*## attribute driverCode */
    bool hiMax;		/*## attribute hiMax */
};

/***    User implicit entries    ***/


/* Constructors and destructors:*/

/*## operation Init() */
void SPI_Init( void );

/*## auto_generated */
void SPI_Cleanup( void );

/***    User explicit entries    ***/


/* Operations */

/*## operation delay(uint32_t) */
void SPI_delay(uint32_t aCnt);

/*## operation initialize() */
void SPI_initialize( void );

/*## operation isHiMax() */
RiCBoolean SPI_isHiMax( void );

/*## operation rd_id_man() */
int16_t SPI_rd_id_man( void );

/* Write a command the LCD controller */
/* Parameter:    cmd:    command to be written */
/* Return: */
/*## operation wr_cmd(uint8_t) */
void SPI_wr_cmd(const uint8_t aCmd);

/* Write data to the LCD controller */
/*  Parameter:    dat:    data to be written  */
/*  Return:  */
/*## operation wr_dat(uint16_t) */
void SPI_wr_dat(const uint16_t aDat);

/* Data writing to the LCD controller */
/*   Parameter:    dat:    data to be written */
/*   Return:                                                        */
/*## operation wr_dat_only(uint16_t) */
void SPI_wr_dat_only(const uint16_t aDat);

/* Start of data writing to the LCD controller */
/*    Parameter: */
/*    Return: */
/*## operation wr_dat_start() */
void SPI_wr_dat_start( void );

/* Stop of data writing to the LCD controller */
/*   Parameter: */
/*   Return: */
/*## operation wr_dat_stop() */
void SPI_wr_dat_stop( void );

/* Write a value to the to LCD register */
/* Parameter:    reg:    register to be written */
/*                     val:    value to write to the register */
/*## operation wr_reg(uint8_t,uint16_t) */
void SPI_wr_reg(const uint8_t aReg, const uint16_t aVal);

/*## auto_generated */
int16_t SPI_getDriverCode( void );


/*#[ ignore */

/* Beginning stop section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_STOP_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_STOP_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending stop section to allocate CODE and DATA into Memory Sections */


/*#]*/

#endif
/*********************************************************************
	File Path	: Cortex_CMP\Debug\SPI.h
*********************************************************************/
