/*********************************************************************
	Rhapsody in C	: 8.2.1 
	Login		: LocalAdministrator
	Component	: Cortex_CMP 
	Configuration 	: Debug
	Model Element	: Screen
//!	Generated Date	: Sat, 19, Aug 2017  
	File Path	: Cortex_CMP\Debug\Screen.h
*********************************************************************/

#ifndef Screen_H
#define Screen_H

/*## auto_generated */
#include "WST.h"
/*## auto_generated */
#include <stdint.h>
/*## auto_generated */
#include <stdbool.h>
/*## auto_generated */
#include "c_App_Pkg.h"
/*## auto_generated */
#include "WST_FSM.h"
/*## auto_generated */
#include "WST_EVT.h"
/*## classInstance itsGLCD */
#include "GLCD.h"
/*## classInstance itsRectangle */
#include "Rectangle.h"
/*#[ ignore */
#define Screen_Timeout_Idle_id 1
/*#]*/

/*## package c_App_Pkg */

/*## class Screen */

/*#[ ignore */

/* Beginning start section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_START_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_START_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending start section to allocate CODE and DATA into Memory Sections */


/*#]*/


typedef struct Screen Screen;
struct Screen
{
    WST_FSM ric_reactive;
    struct GLCD itsGLCD;		/*## classInstance itsGLCD */
    struct Rectangle itsRectangle;		/*## classInstance itsRectangle */
    /*#[ ignore */
    int rootState_subState;
    int rootState_active;
    /*#]*/
};

/***    User implicit entries    ***/


/* Constructors and destructors:*/

/*## operation Init() */
void Screen_Init(Screen* const me, WST_TSK * p_task);

/*## auto_generated */
void Screen_Cleanup(Screen* const me);

/*## auto_generated */
struct GLCD* Screen_getItsGLCD(const Screen* const me);

/*## auto_generated */
struct Rectangle* Screen_getItsRectangle(const Screen* const me);

/*## auto_generated */
Screen * Screen_Create(WST_TSK * p_task);

/*## auto_generated */
void Screen_Destroy(Screen* const me);

/*## auto_generated */
RiCBoolean Screen_startBehavior(Screen* const me);

/***    Framework entries    ***/

/* rootState: */
/*## statechart_method */
int Screen_rootState_IN(const Screen* const me);

/* Idle: */
/*## statechart_method */
int Screen_Idle_IN(const Screen* const me);

/* Active: */
/*## statechart_method */
int Screen_Active_IN(const Screen* const me);

/*#[ ignore */
enum Screen_Enum
{
    Screen_RiCNonState = 0,
    Screen_Idle = 1,
    Screen_Active = 2
};
/*#]*/


/*#[ ignore */

/* Beginning stop section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_STOP_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_STOP_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending stop section to allocate CODE and DATA into Memory Sections */


/*#]*/

#endif
/*********************************************************************
	File Path	: Cortex_CMP\Debug\Screen.h
*********************************************************************/
