/*********************************************************************
	Rhapsody in C	: 8.2.1 
	Login		: LocalAdministrator
	Component	: Cortex_CMP 
	Configuration 	: Debug
	Model Element	: Screen
//!	Generated Date	: Sat, 19, Aug 2017  
	File Path	: Cortex_CMP\Debug\Screen.c
*********************************************************************/

/*## auto_generated */
#include "WST_RXF.h"
/*## auto_generated */
#include "Screen.h"
/*## package c_App_Pkg */

/*## class Screen */

/*#[ ignore */

/* Beginning start section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_START_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_START_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending start section to allocate CODE and DATA into Memory Sections */


/*#]*/


/*## auto_generated */
static void initRelations(Screen* const me);

/*## auto_generated */
static void initStatechart(Screen* const me);

/*## auto_generated */
static void cleanUpRelations(Screen* const me);

/*## statechart_method */
static void rootState_entDef(void * const void_me);

/*## statechart_method */
static RiCTakeEventStatus rootState_dispatchEvent(void * const void_me, short id);

/*#[ ignore */
static void FreeInstance(Screen* const me);
/*#]*/

/*## operation Init() */
void Screen_Init(Screen* const me, WST_TSK * p_task)
{
    /* Virtual tables Initialization */
    static const WST_FSM_Vtbl Screen_reactiveVtbl = {
        rootState_dispatchEvent,
        rootState_entDef,
        NULL,
        (RiCObjectDestroyMethod) Screen_Destroy,
        NULL,
        NULL,
        NULL,
        (RiCObjectCleanupMethod) Screen_Cleanup,
        (RiCObjectFreeMethod) FreeInstance
    };
    WST_FSM_init(&(me->ric_reactive), (void*)me, p_task, &Screen_reactiveVtbl);
    /* In WST RXF we do not need to set an active flag in FSM. */
    initRelations(me);
    initStatechart(me);
    {
        /*#[ operation Init() */
        GLCD_Clear(&me->itsGLCD);
    
        /*#]*/
    }
}

void Screen_Cleanup(Screen* const me)
{
    WST_FSM_cleanup(&(me->ric_reactive));
    cleanUpRelations(me);
}

struct GLCD* Screen_getItsGLCD(const Screen* const me)
{
    return (struct GLCD*)&(me->itsGLCD);
}

struct Rectangle* Screen_getItsRectangle(const Screen* const me)
{
    return (struct Rectangle*)&(me->itsRectangle);
}

Screen * Screen_Create(WST_TSK * p_task)
{
    Screen* me = (Screen *) malloc(sizeof(Screen));
    if(me!=NULL)
        {
            Screen_Init(me, p_task);
        }
    DYNAMICALLY_ALLOCATED(me);
    return me;
}

void Screen_Destroy(Screen* const me)
{
    if(me!=NULL)
        {
            Screen_Cleanup(me);
        }
    free(me);
}

RiCBoolean Screen_startBehavior(Screen* const me)
{
    RiCBoolean done = RiCTRUE;
    done &= WST_FSM_startBehavior(&(me->ric_reactive));
    return done;
}

static void initRelations(Screen* const me)
{
    GLCD_Init(&(me->itsGLCD), OR_Landscape, PO_Straight);
    Rectangle_Init(&(me->itsRectangle), 10, 10, 20, 20, clrYellow);
    Rectangle_setItsGLCD(&(me->itsRectangle), &(me->itsGLCD));
}

static void initStatechart(Screen* const me)
{
    me->rootState_subState = Screen_RiCNonState;
    me->rootState_active = Screen_RiCNonState;
}

static void cleanUpRelations(Screen* const me)
{
    Rectangle_Cleanup(&(me->itsRectangle));
    GLCD_Cleanup(&(me->itsGLCD));
}

int Screen_rootState_IN(const Screen* const me)
{
    return 1;
}

int Screen_Idle_IN(const Screen* const me)
{
    return me->rootState_subState == Screen_Idle;
}

int Screen_Active_IN(const Screen* const me)
{
    return me->rootState_subState == Screen_Active;
}

static void rootState_entDef(void * const void_me)
{
    
    Screen * const me = (Screen *)void_me;
    {
        me->rootState_subState = Screen_Idle;
        me->rootState_active = Screen_Idle;
        WST_TSK_schedTm(me->ric_reactive.myTask, 10, Screen_Timeout_Idle_id, &(me->ric_reactive), NULL);
    }
}

static RiCTakeEventStatus rootState_dispatchEvent(void * const void_me, short id)
{
    
    Screen * const me = (Screen *)void_me;
    RiCTakeEventStatus res = eventNotConsumed;
    /* State Idle */
    if(me->rootState_active == Screen_Idle)
        {
            /*## transition 1 */
            if(id == Timeout_id)
                {
                    if(RiCTimeout_getTimeoutId((RiCTimeout*) me->ric_reactive.current_event) == Screen_Timeout_Idle_id)
                        {
                            WST_TSK_unschedTm(me->ric_reactive.myTask, Screen_Timeout_Idle_id, &(me->ric_reactive));
                            me->rootState_subState = Screen_Active;
                            me->rootState_active = Screen_Active;
                            {
                                /*#[ state Active.(Entry) */
                                GLCD_ClearColor(&me->itsGLCD, clrWhite);
                                
                                GLCD_DisplayString( &me->itsGLCD, 1, 5, 1,"It Works!");
                                
                                /*#]*/
                            }
                            res = eventConsumed;
                        }
                }
        }
    return res;
}

/*#[ ignore */
static void FreeInstance(Screen* const me)
{
    free(me);
}
/*#]*/


/*#[ ignore */

/* Beginning stop section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_STOP_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_STOP_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending stop section to allocate CODE and DATA into Memory Sections */


/*#]*/

/*********************************************************************
	File Path	: Cortex_CMP\Debug\Screen.c
*********************************************************************/
