/*********************************************************************
	Rhapsody in C	: 8.2.1 
	Login		: LocalAdministrator
	Component	: Cortex_CMP 
	Configuration 	: Debug
	Model Element	: a_SPI_Lib
//!	Generated Date	: Sat, 19, Aug 2017  
	File Path	: Cortex_CMP\Debug\a_SPI_Lib.h
*********************************************************************/

#ifndef a_SPI_Lib_H
#define a_SPI_Lib_H

/*## auto_generated */
#include "WST.h"
/*## auto_generated */
#include <stdint.h>
/*## auto_generated */
#include <stdbool.h>
/*## classInstance SPI */
struct SPI_t;

/*## package a_SPI_Lib */


/*#[ ignore */
/* SPI Interface: SPI3 */
/*     */
/*    PINS:  */
/*    - CS     = P0.6 (GPIO pin) */
/*    - RS     = GND */
/*    - WR/SCK = P0.7 (SCK1) */
/*    - RD     = GND */
/*    - SDO    = P0.8 (MISO1) */
/*    - SDI    = P0.9 (MOSI1)  */
/*  */
/*#]*/

/*#[ ignore */

/* Beginning start section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_START_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_START_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending start section to allocate CODE and DATA into Memory Sections */


/*#]*/


/*#[ ignore */
/* #define LCD_CS(x)   ((x) ? (LPC_GPIO0->FIOSET = PIN_CS)    : (LPC_GPIO0->FIOCLR = PIN_CS)) */
#define LCD_CS(x)	 ((x) ? (LPC_GPIO0->FIOSET = PIN_CS)    : (LPC_GPIO0->FIOCLR = PIN_CS))
/* #define LCD_CLK(x)  ((x) ? (LPC_GPIO0->FIOSET = PIN_CLK)   : (LPC_GPIO0->FIOCLR = PIN_CLK)) */
#define LCD_CLK(x)	  ((x) ? (LPC_GPIO0->FIOSET = PIN_CLK)   : (LPC_GPIO0->FIOCLR = PIN_CLK))
/* #define LCD_DAT(x)  ((x) ? (LPC_GPIO0->FIOSET = PIN_DAT)   : (LPC_GPIO0->FIOCLR = PIN_DAT)) */
#define LCD_DAT(x)	  ((x) ? (LPC_GPIO0->FIOSET = PIN_DAT)   : (LPC_GPIO0->FIOCLR = PIN_DAT))
/* #define DAT_MODE(x) ((x == OUT) ? (LPC_GPIO0->FIODIR |= PIN_DAT) : (LPC_GPIO0->FIODIR &= ~PIN_DAT)) */
#define DAT_MODE(x) ((x == DM_OUT) ? (LPC_GPIO0->FIODIR |= PIN_DAT) : (LPC_GPIO0->FIODIR &= ~PIN_DAT))
#define BUS_VAL()	 ((LPC_GPIO0->FIOPIN & PIN_DAT) != 0)
/* #define DELAY_2N    18 */
#define DELAY_2N	18
/*#]*/

/*## attribute BSY */
#define BSY 0x10

/*## attribute PIN_CLK */
#define PIN_CLK (1 << 7)

/* #define PIN_CS      (1 << 6) */
/*## attribute PIN_CS */
#define PIN_CS (1 << 6)

/*## attribute PIN_DAT */
#define PIN_DAT (1 << 9)

/*## attribute RNE */
#define RNE 0x04

/*  RS bit 1 within start byte */
/*## attribute SPI_DATA */
#define SPI_DATA (0x02)

/*  RS bit 0 within start byte */
/*## attribute SPI_INDEX */
#define SPI_INDEX (0x00)

/* WR bit 1 within start */
/*## attribute SPI_RD */
#define SPI_RD (0x01)

/* Start byte for SPI transfer */
/*## attribute SPI_START */
#define SPI_START (0x70)

/* WR bit 0 within start */
/*## attribute SPI_WR */
#define SPI_WR (0x00)

/*## attribute TFE */
#define TFE 0x01

/* SPI Interface: SPI3 */
/*     */
/* PINS:  */
/*  - CS     = P0.6 (GPIO pin) */
/*  - RS     = GND */
/*  - WR/SCK = P0.7 (SCK1) */
/*  - RD     = GND */
/*  - SDO    = P0.8 (MISO1) */
/*  - SDI    = P0.9 (MOSI1)  */
/*## classInstance SPI */
extern struct SPI_t SPI;

/*## auto_generated */
void a_SPI_Lib_initRelations( void );


/*#[ ignore */

/* Beginning stop section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_STOP_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_STOP_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending stop section to allocate CODE and DATA into Memory Sections */


/*#]*/

#endif
/*********************************************************************
	File Path	: Cortex_CMP\Debug\a_SPI_Lib.h
*********************************************************************/
